var MPP = (function() {
    var ajax = function(url, callback, error) {
        var xhr = new XMLHttpRequest();
        xhr.onreadystatechange = function() {
            if (xhr.readyState == 4) {
                if (xhr.status == 200) {
                    callback(xhr.responseText);
                } else if (error) {
                    error(xhr);
                }
            }
        };
        xhr.open('GET', url);
        xhr.send();
    };

    var req = function(func, params, callback) {
        var escapedParams = [];
        for (var k in params) {
            escapedParams.push(k+'='+encodeURIComponent(params[k]));
        }
        var url = 'mpp-api://'+func+'?'+escapedParams.join('&');
        ajax(url, callback, function(xhr) {
            callback(xhr.responseText);
        });
    };

    return {
        brand: "NewsHerald",

        getArticleId: function(callback) {
            callback(Android.getArticleId());
        },

        getAppData: function(callback) {
            json = eval( '(' + Android.getAppData() + ')' );
            callback(json);
        },

        getArticleContent: function(articleId, callback) {
            json = eval( '(' + Android.getArticleData(articleID) + ')' );
            callback(json);
        },

        getArticleData: function(articleID, callback) {
            json = eval( '(' + Android.getArticleData(articleID) + ')' );
            callback(json);
        },

        injectSocialCounts: function(articleURL, elementID) {
            ajax("http://tools.freerange360.com/tools/countshtml.php?pl=and&url=" + escape(articleURL) + "&br=" + MPP.brand, function(data) {
                document.getElementById(elementID).innerHTML = data;
            }, function(xhr) {
                document.getElementById(elementID).innerHTML = '';
            });
        },

        log: function() {
            Android.log(arguments);
        },

        shareToFacebook: function(articleID) {
            req('shareToTwitter', {articleID:articleID}, function(){});
        },
        
        shareToTwitter: function(articleID) {
            req('shareToTwitter', {articleID:articleID}, function(){});
        },
        
        showImages: function(articleID) {
            Android.showImages(articleID);
        },

        showMovie: function(articleID) {
            req('showMovie', {articleID:articleID}, function(){});
        }
    };
})();
